#define ALWAYS_ENABLED     1
#define NOT_ALWAYS_ENABLED 0

/* you should have three field defined for each printer:
 *   1. printer name string 
 *   2. printer command  with '%s' substituted for the file name.
 *   3. A constant specifying whether a printer should be
 *      disabled when the noprint option in on or for anonymous users
 *
 * !!!DO NOT remove the empty strings at the end!!!
 *
 * Multiline printer names will have the top line highlighted
 *
 *  The printer structure looks like: 
 *
 * struct _printer_type {
 *    char name[256];                     * a description of the printer 
 *    char command[256];                  * the command to print 
 *    int  always_enabled;                * a constant to tell whether or
 *                                        * not to disable the printer
 *                                        * when the no_print option is on.
 * }
 */
/*    example printers!  you may specify an unlimited number of printers
*
*  printer_type printer[] = {
*	{"Line printer outside of Customer Assistance at the Comp Center",
*	 "enq -Pccprt %s", 
*	 NOT_ALWAYS_ENABLED},
*
*	{"Line printer inside of Customer Assistance at the Comp Center",
*	 "enq -Psys %s", 
*	 NOT_ALWAYS_ENABLED},
*
*	{"Laser writer in Customer Assistance at the Comp. Center",
*	 "enq -Plw %s", 
*	 NOT_ALWAYS_ENABLED},
*
*	{"PostScript Laser writer in Customer Assistance at the Comp Center",
*	 "enq -Plwps %s", 
*	 NOT_ALWAYS_ENABLED},
*
*        {"Send the file to yourself with Kermit\n        After selecting, go into kermit recieve mode to accept the file",
*	"/homea/local/bin/ckermit s %s", 
*	 ALWAYS_ENABLED},
*
*	{"Specify your own print command",
*	"echo -n \"Enter a print command: \"; read word; sh -c \"$word %s\"", 
*	 NOT_ALWAYS_ENABLED},
*
*	{" ", " ",0},
*  };
*/

/* Put your real printers here! */

printer_type printer[] = {
	{"Specify your own print command",
	"echo -n \"Enter a print command: \"; read word; sh -c \"$word %s\"", 
	 NOT_ALWAYS_ENABLED},

	{" ", " ", 0},
  };
