!	Make LYNX hypertext browser under VMS
!       =====================================
!
! History:
!  1/1/93  creation at KU (Lou montulli@ukanaix.cc.ukans.edu). 
!  4/12/93 (seb@lns61.tn.cornell.edu)
!           modified to support either UCX or MULTINET
! Instructions:
!	Use the correct command line for your TCP/IP implementation:
!
!	$ MMS/MACRO=(MULTINET=1)	for Multinet (default)
!not yet$ MMS/MACRO=(WIN_TCP=1)		for Wollongong TCP/IP
!	$ MMS/MACRO=(UCX=1)		for DEC/UCX
!
.IFDEF UCX
!
!!!!!!!!! change [-.www.library.implementation] to the location
!!!!!!!!! of the old VMS version of the WWW library
!
LIBS=  [.gopher]gopher.lib/library, \
       [-.www.library.implementation]wwwlib_ucx.olb/library
OPTION_FILE = ucx.opt
CFLAGS= /DEFINE=(VMS,UCX) /INCLUDE=([-],[-.WWW.Library.Implementation]) 
TCP=UCX
.ENDIF
.IFDEF MULTINET
!
!!!!!!!!! change [-.www.library.implementation] to the location
!!!!!!!!! of the old VMS version of the WWW library
!
LIBS=  [.gopher]gopher.lib/library, \
       [-.www.library.implementation]wwwlib_multinet.olb/library
OPTION_FILE = multinet.opt
CFLAGS= /DEFINE=(VMS,MULTINET) /INCLUDE=([-],[-.WWW.Library.Implementation]) 
TCP=MULTINET
.ENDIF
.IFDEF WIN_TCP
!
!!!!!!!!! change [-.www.library.implementation] to the location
!!!!!!!!! of the old VMS version of the WWW library
!
LIBS=  [.gopher]gopher.lib/library, \
       [-.www.library.implementation]wwwlib_win_tcp.olb/library
OPTION_FILE = win_tcp.opt
CFLAGS= /DEFINE=(VMS,WIN_TCP) /INCLUDE=([-],[-.WWW.Library.Implementation]) 
TCP=WIN_TCP
.ENDIF
.IFDEF LIBS
.ELSE
! (Default to multinet)
!
!!!!!!!!! change [-.www.library.implementation] to the location
!!!!!!!!! of the old VMS version of the WWW library
!
LIBS=  [.gopher]gopher.lib/library, \
       [-.www.library.implementation]wwwlib_multinet.olb/library
OPTION_FILE = multinet.opt
CFLAGS= /DEFINE=(VMS,MULTINET) /INCLUDE=([-],[-.WWW.Library.Implementation]) 
TCP=MULTINET
.ENDIF
!
LFLAGS= 
!
OBJS= main.obj, highlight.obj, push.obj, curses.obj, \
do_remote_command.obj, do_port_emulator.obj, \
linewrap.obj, get_file_lines.obj, \
mainloop.obj, showpage.obj, indomain.obj, \
mygetch.obj, statusline.obj, getlinkname.obj, \
interaddr.obj, nextword.obj, clean_sig.obj, \
gettargetname.obj, findtarget.obj, ismoretext.obj, \
refinehightext.obj, showhistory.obj, \
exec_a_command.obj, clean_files.obj, textsearch.obj, \
historytarget.obj, mailmsg.obj, \
reply_by_mail.obj, checkfordefines.obj, \ 
uncapitalize.obj, size_change.obj, \
display_a_line.obj, showinfo.obj, defineswitch.obj, \
mystrstr.obj, printfile.obj, edit_current_file.obj, \
parselinks.obj, do_command.obj, linkless_search.obj, \
do_telnet.obj, getfile.obj, remove_backslashes.obj, \
termio.obj, do_rexec.obj, print_to_fd.obj, CHANGE_FORM_LINK.obj, \
DO_LINK.obj, OPTIONS.obj, PARSEFORMLINKS.obj, PRINT_OPTIONS.obj, \
READ_RC.obj, SAVE_FORM.obj, SAVE_HOMEPAGE_LINK.obj, \
SUBMIT_FORM.obj, WRITE_FORM_LINKS_TO_SOCK.obj, \
ASSIGN_FORM_LINK_TYPES.obj, FORM_GETSTR.obj, \
PARSE_TAG.obj, SAVE_RC.obj, process_date.obj, \
is_url.obj, parse_gopher_url.obj, get_homepage_name.obj \
convert_gopher_link.obj, replaceb.obj, tempname.obj, \
number2arrows.obj, follow_link_number.obj, \
target_in_links.obj, remove_homepage_link.obj, sug_filename.obj

lynx.exe : gopher, www, $(OBJS) 
	link /executable=lynx.exe $(LFLAGS) $(OPTION_FILE)/opt, $(LIBS)  
	copy lynx.exe [-]lynx.exe

gopher : 
	SET DEFAULT [.gopher]
	mms /MACRO=($(TCP)=1)
	SET DEFAULT [-]

www :
	SET DEFAULT [.www]
	mms /MACRO=($(TCP)=1)
	SET DEFAULT [-]


main.obj : [-]printers.h, [-]userdefs.h

mainloop.obj : [-]userdefs.h
