#include "mydefs.h"

/*
*****************************************************************
*								*
*								*
*		DoAction()					*
* performs curses routines					*
*****************************************************************
*/

DoAction( int PreviousInput, int out_state, int *CharSet)
{
	static int cur_X = 0, cur_Y = 0, int1 = -1, int2 = -1, int2a = -1;
	static int int3 = -1, int4 = -1, int4a = -1, save_X = 0, save_Y = 0;
	static val1 = 0, val2 = 0;
	static int GraphicsValue;
	int i;

	switch(out_state) {

	case 0: /* if not an escape sequence or a control
		 * character then add it to the screen 
		 */	
		if (*CharSet == ASCII) 
			addch((char)PreviousInput);
		else if (*CharSet == GRAPHICS) {
		switch(PreviousInput) {
			case 106: 
			case 107:
			case 108:
			case 109:addch('+');
			 	 break;
			case 113:addch('-');
			 	 break;
			case 120:addch('|');
		         	 break;
			}
		}
		cur_Y++;
		

		int1 = -1; int2 = -1; int3 = -1; int4 = -1; int2a = -1; int4a = -1;
		val1 = 0; val2 = 0;
		break;

	case 2: int1 = -1; int2 = -1; int3 = -1; int4 = -1; int2a = -1; int4a = -1;
		val1 = 0;			/* initialize all of the variables */
		val2 = 0;
		GraphicsValue = 0;
		break;

	case 4: int1 = val1 = (PreviousInput - 48);	/* initialize 1st digit of the first integer */
		break;

	case 5: int2 = PreviousInput - 48;		/* initialize 2nd digit of the first integer */
		val1 = 10*val1 + int2;
		break;

	case 23:
	case 7: int3 = val2 = (PreviousInput - 48);	/* initialize 1st digit of the second integer */
		break;

	case 8:	if (val1 > 0)				/* perform a move */
			cur_X = val1 - 1;		/* CSI	Pr;Pc H	Set cursor to row Pr,column Pc (same as HVP) */
							/* CSI	Pr;Pc f Set cursor to row Pr, column Pc */
		else
			cur_X = 0;

		if (val2 > 0)
			cur_Y = val2 - 1;
		else
			cur_Y = 0;
		move(cur_X,cur_Y);
		break;

	case 25:
	case 9:  int4 = PreviousInput - 48;		/* initialize 2nd digit of the second integer */
		 val2 = 10*int3 + int4;
		 break;

	case 10:  standend();
							/* if m=0 Attributes 1,4,5 7 off and restore original colors */

		 break;

	case 11: cur_X = 0; cur_Y = 0;			/* move cursor to home CSI	0;0 H or CSI H */
		 move(cur_X,cur_Y);
		 break;

	case 12: fflush(stdout);			/* CSI	2  J	Erase entire screen, reset lines to single width,
							  cursor does not move */
		 clear();
		 fflush(stdin);
		 refresh();
		 move(cur_X,cur_Y);
		 break;

	case 13: break;

	case 14: save_X = cur_X; save_Y = cur_Y;	/* ESC	7	Save cursor position, GL and GR character sets,
							  wrap flag, origin mode. */

	         break;

	case 15: cur_X = save_X;cur_Y = save_Y;
		 break;

	case 16: cur_Y = 0;				/* ESC	8	Restore cursor and other information from above */
		 move(cur_X,cur_Y);
		 break;


	case 17: break;

	case 18: 					/* CSI	Pn A	Cursor up Pn lines, does not scroll */
		 if (val1 > 0)
		 	cur_X = cur_X - val1;
		 else
			cur_X--; 
		 move(cur_X,cur_Y);
		 break;


	case 19: if (val1 > 0)				/* CSI 	Pn B	Cursor down Pn lines, does not scroll */
			cur_X = cur_X + val1;
		 else
			cur_X++;
		 move(cur_X,cur_Y);
		 break;

	case 20: if (val1 > 0)				/* CSI	Pn C	Cursor forward, stays on same line */
			 cur_Y = cur_Y + val1;
		 else
			 cur_Y++;
		 move(cur_X,cur_Y);
		 break;

	case 21: if (val1 > 0)				/* CSI	Pn D	Cursor backward, stays on same line */
		 	cur_Y = cur_Y - val1;
		 else
			cur_Y--;
	         move(cur_X,cur_Y);
		 break;


	/* CSI	Ps;.Ps m	Select graphic rendition
		0	Attributes 1,4,5 7 off and restore original colors
		1	Bold(intensify foreground)
		4	Underline(reverse video with non-Mono video adapters
		5	Blink
		7	Reverse video, per character
	*/

	case 22:
		if (GraphicsValue == 0) {
			standend();
			GraphicsValue++;
		}
		else
			GraphicsValue++; 
	
		 if (int3 != -1){
	     	switch(int3) {
	
		case 5: 
#ifdef FANCY_CURSES
			attron(A_BLINK);
#endif
			break;
		case 7: 
#ifdef FANCY_CURSES
			attron(A_REVERSE);
#else
			standout();
#endif
			break;
		case 1: 
#ifdef FANCY_CURSES
			attron(A_BOLD);
#else
			standout();
#endif
			break;
		case 4: 
#ifdef FANCY_CURSES
			attron(A_UNDERLINE); 
#endif
			break;
			}
		}
		break;

	case 24: if (GraphicsValue == 0) {
		 	standend();
			GraphicsValue++;
		}
		else
			GraphicsValue++; 

		switch(int3) {
		case 5: 
#ifdef FANCY_CURSES
			attron(A_BLINK);
#endif
			break;
		case 7: 
#ifdef FANCY_CURSES
			attron(A_REVERSE);
#else
			standout();
#endif
			break;
		case 1: 
#ifdef FANCY_CURSES
			attron(A_BOLD);
#else
			standout();
#endif
			break;
		case 4: 
#ifdef FANCY_CURSES
			attron(A_UNDERLINE); 
#endif
			break;
		}
		break;

	case 26: break;


	case 27: clrtoeol();			/* CSI	0  K    Erase from cursor to end of line, inclusive */
		 break;

	case 28: fflush(stdout);		/* ^L		Formfeed, treated as a linefeed */
		 clear();
		 fflush(stdin);
		 cur_X = 0; cur_Y = 0;
		 break; 

	case 30: int2a = PreviousInput - 48;  	/* 3rd digit of the first integer */
		 val1 = 10*val1 + int2a;
		 break;

	case 31: int4a = PreviousInput - 48;  	/* 3rd digit of the second integer */
		 val2 = 10*val2 + int4a;
		 break;

	case 32: for (i=1; i<= val1; i++)	/* CSI Pn @ Insert Pn spaces at and after cursor */
		 {
		 addch(' ');
		 cur_Y = cur_Y + 1;
		 }
		 refresh();
		 break;

	case 33: for (i=1; i<= val1; i++)	/* CSI Pn E ANSI next line do Pn times */
		 {
		 addch('\n');
		 cur_X = cur_X + 1;
		 }
		 refresh();
		 break;


	case 34: for (i=1; i<= val1; i++)	/* CSI Pn F ANSI previous do Pn times */
		 {
		 cur_X = cur_X - 1;
		 cur_Y = 0;
		 move(cur_X,cur_Y);
		 }
		 break;

	case 35: cur_Y = val1;			/* CSI Pc G ANSI cursor to absolute column Pc */
		 move(cur_X,cur_Y);
		 break;

	case 36: for (i=1;i<=val1;i++) 		/* CSI Pn I Cursor forward Pn tabstops */
		 {
		 addch('\t');
		 cur_Y = cur_Y + 7;
		 }
		 refresh();
		 break;


	case 37: for (i=1;i<=val1;i++)		/* CSI Pn L Insert Pn lines preceding current line */
		 {
		 cur_X = cur_X - 1;
		 move(cur_X,cur_Y);
		 }
		 break;

	case 38: for (i=1;i <=val1;i++)		/* CSI Pn M delete Pn lines from current downward */
		 {
		 cur_X = cur_X + 1;
		 move(cur_X,cur_Y);
		 }
		 break;

	case 39: for(i=1;i<=val1;i++)		/* CSI Pn P Delete Pn chars from cursor to left */
		 {
		 cur_Y = cur_Y - 1;
		 move(cur_X,cur_Y);
		 addch(' ');
		 cur_Y = cur_Y - 1;
		 move(cur_X,cur_Y);
		 }
		 break;

	case 40: for (i=1;i<=val1;i++)		/* CSI Pn X Erase Pn chars at and to right of cursor */
		 {
		 addch(' ');
		 cur_Y = cur_Y + 1;
		 }
		 refresh();
		 break;

	case 41: /* beep(); flash(); */		/* Sound DEC-style beep or flash screen */
		 break;

	case  42:   /* ^H Backspace, move cursor left one character */
		if (cur_Y > 1)
		cur_Y = cur_Y - 1;
		move(cur_X,cur_Y);
		break;


	case 43: 
		/* ^I Horizontal tab,move cursor to next tabstop */
		 cur_Y = cur_Y + 8 - (cur_Y % 8);
		 move(cur_X,cur_Y); 
		 break; 

	case 44: 		/* ^J Linefeed, move cursor down one line */
		 cur_X = cur_X + 1;
		 move(cur_X,cur_Y);
		 break;

	case 45: addch('\n');	/*  ^K Vertical Tab, treated as a linefeed */
		 cur_Y = 0;
		 cur_X = cur_X + 1;
		 break;

	case 48: *CharSet = ASCII;
		 break;

	case 49: *CharSet = GRAPHICS;
		 break;


	} /* end of long switch */
} /* end of DoAction */

