#include "mydefs.h"
/*
*****************************************************************
*								*
*				initialize()			*
* initializes the TableLookup 2 dimens array with first index   *
* being the CurrentState and next index being the Input State   *
* action determines which case to use in DoAction.c		*
*****************************************************************
*/
/*
The following control characters and Escape sequences have been implemented

Control Characters:
^G		Sound DEC-style beep or flash screen
^H		Backspace, move cursor left one character
^I		Horizontal tab, move cursor to next tabstop
^J		Linefeed, move cursor down one line
^K		Vertical Tab, treated as a linefeed
^L		Formfeed, treated as a linefeed
^M		Carriage return, move cursor to column 1
^O		Locking shift 0, invoke character set in G0 to GL
^X		Cancel escape or control sequence in progress
^Z		Treated the same as above

*****************************************************************

Escape Sequences:

ESC	7	Save cursor position, GL and GR character sets,
		wrap flag, origin mode.
ESC	8	Restore cursor and other information from above
CSI	Pn @	Insert Pn spaces at and after cursor
CSI	Pn A	Cursor up Pn lines, does not scroll
CSI 	Pn B	Cursor down Pn lines, does not scroll
CSI	Pn C	Cursor forward, stays on same line
CSI	Pn D	Cursor backward, stays on same line
CSI 	Pn E	ANSI next line, do Pn times(new line)
CSI	Pn F	Previous-line (reverse index), do Pn times
CSI	Pc G	ANSI cursor to absolute column Pc
CSI	Pr;Pc H	Set cursor to row Pr,column Pc (same as HVP)
CSI	Pn I	Cursor forward Pn tabstops

CSI	Ps J	Erase in display where Ps = 0,1,2
CSI	0  J	Erase from cursor to end of screen, inclusive
CSI	1  J	Erase from start of screen to cursor inclusive
CSI	2  J	Erase entire screen, reset lines to single width,
		cursor does not move

CSI	Ps K	Erase in line
CSI	0  K    Erase from cursor to end of line, inclusive
CSI	1  K 	Erase from start of line to cursor, inclusive
CSI	2  K 	Erase entire line, cursor does not move

CSI	Pn L	Insert Pn lines preceding current line
CSI	Pn M	Delete Pn lines from current downward
CSI	Pn P	Delete Pn chars from cursor to left
CSI	Pn X	Erase Pn chars at and right of cursor
CSI	Pr;Pc f Set cursor to row Pr, column Pc
CSI	Pa;.Pa lReset ANSI mode
CSI	Ps;.Ps m	Select graphic rendition
		0	Attributes 1,4,5 7 off and restore original colors
		1	Bold(intensify foreground)
		4	Underline(reverse video with non-Mono video adapters
		5	Blink
		7	Reverse video, per character

***************************************************************  
*/



initialize(short TableLookup[NUM_STATES][NUM_INPUTS],
	   short NextState[MAX_TRANSITIONS],
	   short Action[MAX_TRANSITIONS])	
{
int i,j;
	/* 
	 * need to initialize the table lookup to -1 since 0 is a valid state
	 */

	for(i=0;i<=NUM_STATES-1;i++)			
		for(j=0;j<=NUM_INPUTS-1;j++)
			TableLookup[i][j] = -1;



TableLookup[1][13] = 0; 	NextState[0] = 1; 	Action[0] = 16; 
TableLookup[1][15]  = 1; 	NextState[1] = 1; 	Action[1] = 26; 
TableLookup[1][27] = 2; 	NextState[2] = 2; 	Action[2] = 2; 
TableLookup[2][91] = 3; 	NextState[3] = 3; 	Action[3] = 3; 
TableLookup[2][55] = 4; 	NextState[4] = 1; 	Action[4] = 14; 
TableLookup[2][56] = 5; 	NextState[5] = 1; 	Action[5] = 15; 
TableLookup[2][95] = 170;       NextState[170] = 1;     Action[170] = APC; 
TableLookup[3][48] = 6; 	NextState[6] = 4; 	Action[6] = 4; 
TableLookup[3][49] = 7; 	NextState[7] = 4; 	Action[7] = 4; 
TableLookup[3][50] = 8; 	NextState[8] = 4; 	Action[8] = 4; 
TableLookup[3][51] = 9; 	NextState[9] = 4; 	Action[9] = 4; 
TableLookup[3][52] = 10; 	NextState[10] = 4; 	Action[10] = 4; 
TableLookup[3][53] = 11; 	NextState[11] = 4; 	Action[11] = 4; 
TableLookup[3][54] = 12; 	NextState[12] = 4; 	Action[12] = 4; 
TableLookup[3][55] = 13; 	NextState[13] = 4; 	Action[13] = 4; 
TableLookup[3][56] = 14; 	NextState[14] = 4; 	Action[14] = 4; 
TableLookup[3][57] = 15; 	NextState[15] = 4; 	Action[15] = 4; 
TableLookup[3][72] = 16; 	NextState[16] = 1; 	Action[16] = 11; 
TableLookup[3][75] = 17; 	NextState[17] = 1; 	Action[17] = 27; 
TableLookup[3][109] = 18; 	NextState[18] = 1; 	Action[18] = 10; 
TableLookup[3][65] = 19; 	NextState[19] = 1; 	Action[19] = 18; 
TableLookup[3][66] = 20; 	NextState[20] = 1; 	Action[20] = 19; 
TableLookup[3][67] = 21; 	NextState[21] = 1; 	Action[21] = 20; 
TableLookup[3][68] = 22; 	NextState[22] = 1; 	Action[22] = 21; 
TableLookup[4][48] = 23; 	NextState[23] = 5; 	Action[23] = 5; 
TableLookup[4][49] = 24; 	NextState[24] = 5; 	Action[24] = 5; 
TableLookup[4][50] = 25; 	NextState[25] = 5; 	Action[25] = 5; 
TableLookup[4][51] = 26; 	NextState[26] = 5; 	Action[26] = 5; 
TableLookup[4][52] = 27; 	NextState[27] = 5; 	Action[27] = 5; 
TableLookup[4][53] = 28; 	NextState[28] = 5; 	Action[28] = 5; 
TableLookup[4][54] = 29; 	NextState[29] = 5; 	Action[29] = 5; 
TableLookup[4][55] = 30; 	NextState[30] = 5; 	Action[30] = 5; 
TableLookup[4][56] = 31; 	NextState[31] = 5; 	Action[31] = 5; 
TableLookup[4][57] = 32; 	NextState[32] = 5; 	Action[32] = 5; 
TableLookup[4][74] = 33; 	NextState[33] = 1; 	Action[33] = 12; 
TableLookup[4][108] = 34; 	NextState[34] = 1; 	Action[34] = 17; 
TableLookup[4][59] = 35; 	NextState[35] = 6; 	Action[35] = 6; 
TableLookup[4][65] = 36; 	NextState[36] = 1; 	Action[36] = 18; 
TableLookup[4][66] = 37; 	NextState[37] = 1; 	Action[37] = 19; 
TableLookup[4][67] = 38; 	NextState[38] = 1; 	Action[38] = 20; 
TableLookup[4][68] = 39; 	NextState[39] = 1; 	Action[39] = 21; 
TableLookup[5][59] = 40; 	NextState[40] = 6; 	Action[40] = 6; 
TableLookup[5][65] = 41; 	NextState[41] = 1; 	Action[41] = 18; 
TableLookup[5][66] = 42; 	NextState[42] = 1; 	Action[42] = 19; 
TableLookup[5][67] = 43; 	NextState[43] = 1; 	Action[43] = 20; 
TableLookup[5][68] = 44; 	NextState[44] = 1; 	Action[44] = 21; 
TableLookup[6][48] = 45; 	NextState[45] = 7; 	Action[45] = 7; 
TableLookup[6][49] = 46; 	NextState[46] = 7; 	Action[46] = 7; 
TableLookup[6][50] = 47; 	NextState[47] = 7; 	Action[47] = 7; 
TableLookup[6][51] = 48; 	NextState[48] = 7; 	Action[48] = 7; 
TableLookup[6][52] = 49; 	NextState[49] = 7; 	Action[49] = 7; 
TableLookup[6][53] = 50; 	NextState[50] = 7; 	Action[50] = 7; 
TableLookup[6][54] = 51; 	NextState[51] = 7; 	Action[51] = 7; 
TableLookup[6][55] = 52; 	NextState[52] = 7; 	Action[52] = 7; 
TableLookup[6][56] = 53; 	NextState[53] = 7; 	Action[53] = 7; 
TableLookup[6][57] = 54; 	NextState[54] = 7; 	Action[54] = 7; 
TableLookup[7][48] = 55; 	NextState[55] = 9; 	Action[55] = 9; 
TableLookup[7][49] = 56; 	NextState[56] = 9; 	Action[56] = 9; 
TableLookup[7][50] = 57; 	NextState[57] = 9; 	Action[57] = 9; 
TableLookup[7][51] = 58; 	NextState[58] = 9; 	Action[58] = 9; 
TableLookup[7][52] = 59; 	NextState[59] = 9; 	Action[59] = 9; 
TableLookup[7][53] = 60; 	NextState[60] = 9; 	Action[60] = 9; 
TableLookup[7][54] = 61; 	NextState[61] = 9; 	Action[61] = 9; 
TableLookup[7][55] = 62; 	NextState[62] = 9; 	Action[62] = 9; 
TableLookup[7][56] = 63; 	NextState[63] = 9; 	Action[63] = 9; 
TableLookup[7][57] = 64; 	NextState[64] = 9; 	Action[64] = 9; 
TableLookup[7][72] = 65; 	NextState[65] = 1; 	Action[65] = 8; 
TableLookup[7][114] = 66; 	NextState[66] = 1; 	Action[66] = 13; 
TableLookup[9][72] = 67; 	NextState[67] = 1; 	Action[67] = 8; 
TableLookup[9][114] = 68; 	NextState[68] = 1; 	Action[68] = 13; 
TableLookup[3][59] = 69; 	NextState[69] = 22; 	Action[69] = 22; 
TableLookup[22][48] = 70; 	NextState[70] = 23; 	Action[70] = 23; 
TableLookup[22][49] = 71; 	NextState[71] = 23; 	Action[71] = 23; 
TableLookup[22][50] = 72; 	NextState[72] = 23; 	Action[72] = 23; 
TableLookup[22][51] = 73; 	NextState[73] = 23; 	Action[73] = 23; 
TableLookup[22][52] = 74; 	NextState[74] = 23; 	Action[74] = 23; 
TableLookup[22][53] = 75; 	NextState[75] = 23; 	Action[75] = 23; 
TableLookup[22][54] = 76; 	NextState[76] = 23; 	Action[76] = 23; 
TableLookup[22][55] = 77; 	NextState[77] = 23; 	Action[77] = 23; 
TableLookup[22][56] = 78; 	NextState[78] = 23; 	Action[78] = 23; 
TableLookup[22][57] = 79; 	NextState[79] = 23; 	Action[79] = 23; 
TableLookup[23][59] = 80; 	NextState[80] = 22; 	Action[80] = 22; 
TableLookup[23][109] = 81; 	NextState[81] = 1; 	Action[81] = 24; 
TableLookup[23][48] = 82; 	NextState[82] = 25; 	Action[82] = 25; 
TableLookup[23][49] = 83; 	NextState[83] = 25; 	Action[83] = 25; 
TableLookup[23][50] = 84; 	NextState[84] = 25; 	Action[84] = 25; 
TableLookup[23][51] = 85; 	NextState[85] = 25; 	Action[85] = 25; 
TableLookup[23][52] = 86; 	NextState[86] = 25; 	Action[86] = 25; 
TableLookup[23][53] = 87; 	NextState[87] = 25; 	Action[87] = 25; 
TableLookup[23][54] = 88; 	NextState[88] = 25; 	Action[88] = 25; 
TableLookup[23][55] = 89; 	NextState[89] = 25; 	Action[89] = 25; 
TableLookup[23][56] = 90; 	NextState[90] = 25; 	Action[90] = 25; 
TableLookup[23][57] = 91; 	NextState[91] = 25; 	Action[91] = 25; 
TableLookup[23][72] = 92; 	NextState[92] = 1; 	Action[92] = 8; 
TableLookup[25][72] = 93; 	NextState[93] = 1; 	Action[93] = 8; 
TableLookup[1][12] = 94; 	NextState[94] = 1; 	Action[94] = 28; 
TableLookup[5][48] = 96; 	NextState[96] = 5; 	Action[96] = 30;
TableLookup[5][49] = 97; 	NextState[97] = 5; 	Action[97] = 30;
TableLookup[5][50] = 98; 	NextState[98] = 5; 	Action[98] = 30;
TableLookup[5][51] = 99; 	NextState[99] = 5; 	Action[99] = 30;
TableLookup[5][52] = 100; 	NextState[100] = 5; 	Action[100] = 30;
TableLookup[5][53] = 101; 	NextState[101] = 5; 	Action[101] = 30;
TableLookup[5][54] = 102; 	NextState[102] = 5; 	Action[102] = 30;
TableLookup[5][55] = 103; 	NextState[103] = 5; 	Action[103] = 30;
TableLookup[5][56] = 104; 	NextState[104] = 5; 	Action[104] = 30;
TableLookup[5][57] = 105; 	NextState[105] = 5; 	Action[105] = 30;
TableLookup[9][48] = 106; 	NextState[106] = 9; 	Action[106] = 31;
TableLookup[9][49] = 107; 	NextState[107] = 9; 	Action[107] = 31;
TableLookup[9][50] = 108; 	NextState[108] = 9; 	Action[108] = 31;
TableLookup[9][51] = 109; 	NextState[109] = 9; 	Action[109] = 31;
TableLookup[9][52] = 110; 	NextState[110] = 9; 	Action[110] = 31;
TableLookup[9][53] = 111; 	NextState[111] = 9; 	Action[111] = 31;
TableLookup[9][54] = 112; 	NextState[112] = 9; 	Action[112] = 31;
TableLookup[9][55] = 113; 	NextState[113] = 9; 	Action[113] = 31;
TableLookup[9][56] = 114; 	NextState[114] = 9; 	Action[114] = 31;
TableLookup[9][57] = 115; 	NextState[115] = 9; 	Action[115] = 31;
TableLookup[25][48] = 116; 	NextState[116] = 25; 	Action[116] = 31;
TableLookup[25][49] = 117; 	NextState[117] = 25; 	Action[117] = 31;
TableLookup[25][50] = 118; 	NextState[118] = 25; 	Action[118] = 31;
TableLookup[25][51] = 119; 	NextState[119] = 25; 	Action[119] = 31;
TableLookup[25][52] = 120; 	NextState[120] = 25; 	Action[120] = 31;
TableLookup[25][53] = 121; 	NextState[121] = 25; 	Action[121] = 31;
TableLookup[25][54] = 122; 	NextState[122] = 25; 	Action[122] = 31;
TableLookup[25][55] = 123; 	NextState[123] = 25; 	Action[123] = 31;
TableLookup[25][56] = 124; 	NextState[124] = 25; 	Action[124] = 31;
TableLookup[25][57] = 125; 	NextState[125] = 25; 	Action[125] = 31;
TableLookup[3][64] = 126; 	NextState[126] = 1; 	Action[126] = 32;
TableLookup[4][64] = 127; 	NextState[127] = 1; 	Action[127] = 32;
TableLookup[5][64] = 128; 	NextState[128] = 1; 	Action[128] = 32;
TableLookup[3][69] = 129; 	NextState[129] = 1; 	Action[129] = 33;
TableLookup[4][69] = 130; 	NextState[130] = 1; 	Action[130] = 33;
TableLookup[5][69] = 131; 	NextState[131] = 1; 	Action[131] = 33;
TableLookup[3][70] = 132; 	NextState[132] = 1; 	Action[132] = 34;
TableLookup[4][70] = 133; 	NextState[133] = 1; 	Action[133] = 34;
TableLookup[5][70] = 134; 	NextState[134] = 1; 	Action[134] = 34;
TableLookup[3][71] = 135; 	NextState[135] = 1; 	Action[135] = 35;
TableLookup[4][71] = 136; 	NextState[136] = 1; 	Action[136] = 35;
TableLookup[5][71] = 137; 	NextState[137] = 1; 	Action[137] = 35;
TableLookup[7][102] = 138; 	NextState[138] = 1; 	Action[138] = 8;
TableLookup[9][102] = 139; 	NextState[139] = 1; 	Action[139] = 8;
TableLookup[23][102] = 140; 	NextState[140] = 1; 	Action[140] = 8;
TableLookup[25][102] = 141; 	NextState[141] = 1; 	Action[141] = 8;
TableLookup[3][73] = 142; 	NextState[142] = 1; 	Action[142] = 36;
TableLookup[4][73] = 143; 	NextState[143] = 1; 	Action[143] = 36;
TableLookup[5][73] = 144; 	NextState[144] = 1; 	Action[144] = 36;
TableLookup[3][76] = 145; 	NextState[145] = 1; 	Action[145] = 37;
TableLookup[4][76] = 146; 	NextState[146] = 1; 	Action[146] = 37;
TableLookup[5][76] = 147; 	NextState[147] = 1; 	Action[147] = 37;
TableLookup[3][77] = 148; 	NextState[148] = 1; 	Action[148] = 38;
TableLookup[4][77] = 149; 	NextState[149] = 1; 	Action[149] = 38;
TableLookup[5][77] = 150; 	NextState[150] = 1; 	Action[150] = 38;
TableLookup[3][80] = 151; 	NextState[151] = 1; 	Action[151] = 39;
TableLookup[4][80] = 152; 	NextState[152] = 1; 	Action[152] = 39;
TableLookup[5][80] = 153; 	NextState[153] = 1; 	Action[153] = 39;
TableLookup[3][88] = 154; 	NextState[154] = 1; 	Action[154] = 40;
TableLookup[4][88] = 155; 	NextState[155] = 1; 	Action[155] = 40;
TableLookup[5][88] = 156; 	NextState[156] = 1; 	Action[156] = 40;
TableLookup[1][24] = 157; 	NextState[157] = 1; 	Action[157] = 1;
TableLookup[1][26] = 158; 	NextState[158] = 1; 	Action[158] = 1;
TableLookup[1][7] = 159; 	NextState[159] = 1; 	Action[159] = 41;
TableLookup[1][8] = 160; 	NextState[160] = 1; 	Action[160] = 42;
TableLookup[1][9] = 161; 	NextState[161] = 1; 	Action[161] = 43;
TableLookup[1][10] = 162; 	NextState[162] = 1; 	Action[162] = 44;
TableLookup[1][11] = 163; 	NextState[163] = 1; 	Action[163] = 45;
TableLookup[3][63] = 164; 	NextState[164] = 3; 	Action[164] = 3;
TableLookup[5][104] = 165; 	NextState[165] = 1; 	Action[165] = 17;
TableLookup[2][40] = 166; 	NextState[166] = 45; 	Action[166] = 46;
TableLookup[45][66] = 167; 	NextState[167] = 1; 	Action[167] = 48;
TableLookup[2][61] = 168; 	NextState[168] = 1; 	Action[168] = 46;
TableLookup[45][48] = 169;	NextState[169] = 1;	Action[169] = 49;


}
