#include "defs.h"

PUBLIC BOOLEAN getfile ARGS6(char *,newfile, FILE **,fp, 
		char *,gopher_info, int,cur, char *,target, 
		HTAnchor *,www_destination) 
{
	int itmp;
	char *tmptr, *tmptr2;
	char altfile[MAXFNAME];
	char myhostname[12];
        int url_type;

	/* set lynx mode back to normal */
	lynx_mode = NORMAL_LYNX_MODE;

	
	/* check to see if this is a universal document ID
	 * that lib WWW wants to handle
         * we'll do gopher types ourselves because lib www
         * doesnt have complete gopher compatibility
	 */
	  if((url_type = is_url(newfile)) != 0) {
www:
#ifdef TRAVERSAL
		/* only done for traversals IGNORE! */
		if(url_type == HTTP_URL_TYPE) {
		    remove_backslashes(newfile);
                    if(www_destination) {
                        if(!HTLoadAnchor(www_destination))
                            return(NOT_FOUND);
		    }
		} else {
		    return(NULLFILE);
		}
#else
		if(url_type == GOPHER_URL_TYPE) {
		    /* will change url into Lynx recognizeable format */
	            remove_backslashes(newfile);
		    parse_gopher_url(newfile);
		    goto gopher;  /* dont ask!!! Grrr */

		  /* disable www telnet access if not telnet_ok */
		} else if((url_type == TELNET_URL_TYPE || 
				url_type == TN3270_URL_TYPE) ) {

		    if(!telnet_ok) {
		    	statusline("Telnet access is disabled!");
		    	sleep(1);
		    } else {
			stop_curses();
                        chdir(orig_dir);
                        HTLoadAbsolute(newfile, 0);
                        chdir(startdir);
			start_curses();
                        fflush(stdout);

		    }

		    return(NULLFILE);

		} else if(url_type == RLOGIN_URL_TYPE) {

		    stop_curses();
                    chdir(orig_dir);
                    HTLoadAbsolute(newfile, 0);
                    chdir(startdir);
                    fflush(stdout);
		    start_curses();
		    return(NULLFILE);

		} else if(url_type == MAILTO_URL_TYPE) {
		    tmptr = strchr(newfile,':')+1;
		    reply_by_mail(tmptr,"");
		    return(NULLFILE);
		
		} else {
		    statusline(WWW_WAIT_MESSAGE);
	 	    remove_backslashes(newfile);
		    if(www_destination) {
			if(!HTLoadAnchor(www_destination))
			    return(NOT_FOUND);
		    } else {
		        if(!HTLoadAbsolute(newfile, 0))
			    return(NOT_FOUND);
		    }
		    lynx_mode = WWW_LYNX_MODE;
		    return(LOCAL);
		}
#endif TRAVERSAL
	  }

	  tmptr2 = newfile;
          while((tmptr = strchr(tmptr2, '@'))!=NULL) {
		tmptr2 = tmptr+1;
		if(*(tmptr-1)!='\\') {
gopher:
                        /* this is a gopher link */

	       /* check to see whether we have already gotten this file
	        * if we have newfile will be replaced by the local name
	        * and we will open it locally
	        */
	       if(replacebylocal(newfile, gopher_info)) {
	           goto OpenLocal;
		}
		

		/*
		 * Check to see if this is an html gopher link
		 * if it is convert it to be a url and pass it
		 * to WWW
		 */
		 if(!strncmp(newfile,"h-",2)) {
		     convert_gopher_link(newfile);
		     goto www;
		 }

		/* Check to see if the remote hostname is acctually
		 * this local host.  If it is we can save alot of
		 * resources by getting it from the local disk instead
		 * of using gopher to get it
		 */
		    gethostname(myhostname, 8);
		    myhostname[8]='\0';
		 /* if the file is file type FILE and the hostname
		  * is the same as the local host
		  */
		    if(newfile[0]=='0' && mystrstr(newfile,myhostname)!=NULL) {
			char *tmptr3;
			FILE *tmpfp;
			/* remove file type and dash and zero and slash */
			strcpy(altfile,newfile+4);
			tmptr3 = strchr(altfile,'@');
			*tmptr3='\0';  /* get rid of the hostname */
			/* see if we can find and open the file */
			if((tmpfp = fopen(altfile,"r")) != NULL) {
			    fclose(tmpfp);
			    strcpy(newfile,altfile);
			/* open as local disk access */
			    goto OpenLocal;	
			}
		    }

		    /* its not a local file so go get it using gopher */
                    strcpy(gopher_info, do_gopher(newfile, 
					     links[cur].hightext, target, *fp));
		    
		    if(STREQ(gopher_info,"NULL")) 
			return(NULLFILE);

		    if(STREQ(newfile,"#NOT FOUND#")) 
			return(NOT_FOUND);

		    if ((*fp=fopen(newfile, "r")) == NULL) 
			return(NOT_FOUND);
		    else {
                        char strtemp[LINESIZE];
		
                        /* advance file through first page */
                        checkfordefines(*fp);
                        /* checkfordefines will skip over defines at top */
                        for(itmp=1; itmp<=LINES-1 &&
                                fgets(strtemp,LINESIZE,*fp); itmp++)
                                ; /* null body */
                        if(more)
                           fgets(line,LINESIZE,*fp);
                /*'line' is global variable, holding next line in file */
                   	return(GOPHER);
		     } /* end else */
	        } /* end if */
	  } /* end while */


	  /* if its not a gopher file then remove any backslashes that might be
	   * in the name
	   */
	     remove_backslashes(newfile);

	/* local disk access on file */
OpenLocal:
            /*
             * Try to open the new file.
             * If the file is not found in the current directory,
             * try and uncapitalize it, if it is still not found use
             * the first three letters of the filename as a directory name,
             * and try again.  This is for compatibility with HYPERRES,
             * not because I like it.
             */
            
            if ((*fp=fopen(newfile, "r")) != NULL) {

        /* The file wasn't found the first time, so try and uncapitalize
           the filename and open again */
            } else if((*fp=fopen(uncapitalize(newfile), "r")) != NULL) {

        /* The file wasn't found the second time, so try using the first
           three letters of the filename as a directory */
            } else {
                tmptr = strrchr(newfile,'/'); /* point to the last slash */
                if(tmptr) {
                  mystrncpy(altfile, newfile, tmptr-newfile+1);
                  strncat(altfile, tmptr+1, 3);
                  strcat(altfile, tmptr);
                } else { /* there is no slash */
                  mystrncpy(altfile, newfile, 3);
                  strcat(altfile, "/");
                  strcat(altfile, newfile);
                }

                if ((*fp=fopen(altfile, "r")) != NULL) {
                    strcpy(newfile, altfile);
                } else {
		    return(NOT_FOUND);  /* file can't be opened */
		}
	    }

	return(LOCAL);
}  /* end of get file */

