#include "gopher.h"

PUBLIC void gopher_telnet ARGS1(char *,input_line)
{
/* 
 *  input_line is of the form:
 *  type  -	USERNAME [password PASSWORD]@HOST PORT
 */
	char *username=NULL, *password=NULL, *host=NULL;
	char *pass_ptr, *at_ptr, command[120], query[120]; 
	char *space_ptr;
	int response;
	char gopher_type= *input_line;
	char *port=NULL;

	/* initialize */
	username = input_line+2;

	at_ptr = strchr(input_line, '@');  /* find the @ */
	*at_ptr = '\0';

	host = at_ptr+1;

	if((space_ptr = strchr(host, ' ')) != NULL) {
	    *space_ptr = '\0';
	    space_ptr++;
	    while(isspace(*space_ptr)) space_ptr++;
	    if(*space_ptr != '\0')  port = space_ptr;
	}

	if((pass_ptr = strstr(input_line, "password")) != NULL) {
	  /* if username and password exists */
		password = pass_ptr+8;
		*pass_ptr = '\0';
	} 


#ifdef VMS
	if(gopher_type == 'T')
	    sprintf(command,"%s %s %s%s",TN3270_COMMAND, host, 
				port ? "/port=":"", port ? port:"");
	else
	    sprintf(command,"%s %s %s%s",TELNET_COMMAND, host,
				port ? "/port=":"", port ? port:"");
#else
	if(gopher_type == 'T')
	    sprintf(command,"%s %s %s",TN3270_COMMAND, host, port ? port:"");
	else
	    sprintf(command,"%s %s %s",TELNET_COMMAND, host, port ? port:"");
#endif VMS

	/* clear the screen and give the user some info and choices */
	clear();
	addch('\n');
	addch('\n');
	addch('\n');
	addstr("	WARNING:  You are about to leave Lynx and telnet to another site!");
	addch('\n');
	addch('\n');
	addch('\n');
	addstr("	Now connecting to ");
	addstr(host);
	addch('\n');
	addch('\n');
	if(*username != '\0') {
	    addstr("	Use the username ");
	    addstr(username);
	
	   if(password != NULL) {
	       addstr(" and the password ");
	       addstr(password);
	   }

	   addstr(" to logon");
	}	
	sprintf(query,"telnet to %s? (y/n)",host);
	statusline(query);

	response = mygetch();
	
	if(response == RTARROW || response == 'y' || response == 'Y') {
	   statusline(command);
	   stop_curses();
	   system(command);
	   start_curses();
	}
}	
	
	

			
