#include "defs.h"

/*
 * mailmsg sends a message to the ALERTMAIL person and the owner of the
 * file if one is defined telling of errors. (ie link not available)
 */

PUBLIC void mailmsg ARGS4(int,cur, char *,owner_address, 
		char *,filename, char *,linkname)
{
#ifndef MSDOS
	FILE *fd, *ofp;
	char cmd[256], *tmptr;
	char tmpfile[80];
	char *address_ptr1, *address_ptr2;
	BOOLEAN first=TRUE;

	if((tmptr = strchr(owner_address,'\n')) != NULL)
		*tmptr = '\0';

#ifdef UNIX
	/* mail -s "subject line" [owner's_address,] Alertmail */
	sprintf(cmd, "%s -s \"Lynx Error in %s\" %s%s %s",
		(child_lynx ? "mail" : SYSTEM_MAIL), 
		filename, owner_address, 
		(*owner_address=='\0' ? "" : ","), ALERTMAIL);

	if ((fd = popen(cmd, "w")) == NULL) 
			return;
#endif UNIX
#ifdef VMS
	sprintf(tmpfile,"%s%s",TEMP_SPACE, "temp_mail.");
	if((fd = fopen(tmpfile,"w")) == NULL)
	    return;

#endif VMS

	fprintf(fd,"The link   %s :?: %s \n",
                links[cur].lname, links[cur].target);
	fprintf(fd,"called \"%s\"\n",links[cur].hightext);
	fprintf(fd,"in the file \"%s\" called \"%s\"",filename,linkname);

	fputs("\nwas requested but was not available.",fd);
	fputs("\n\nThought you might want to know.",fd);

	fputs("\n\nThis message was automatically generated by Lynx",fd);
#ifdef UNIX
	pclose(fd);
#endif UNIX
#ifdef VMS
	fclose(fd);
	sprintf(cmd, "%s /subject=\"Lynx Error in %s\" %s ",SYSTEM_MAIL,
							filename,tmpfile);

	/* if there is no valid owner address send to alert mail */
	if(strlen(owner_address) < 4)
	    sprintf( &cmd[strlen(cmd)], MAIL_ADRS, ALERTMAIL);

	address_ptr1 = owner_address;
	do {
	    if((tmptr = strchr(address_ptr1,",")) != NULL) {
	        address_ptr2=tmptr+1;
	        *tmptr = '\0';
	    } else
		address_ptr2=NULL;
	
	    if(strlen(owner_address) > 3) {
		if(!first)
		    strcat(cmd, ", ");  /* add a comma and a space */
	        sprintf( &cmd[strlen(cmd)], MAIL_ADRS, address_ptr1);
		first = FALSE;
	    }

	    address_ptr1=address_ptr2;
	} while(address_ptr1!=NULL);

	signal(SIGINT, SIG_IGN);
	system(cmd);
	signal(SIGINT, cleanup_sig);
	remove(tmpfile);
#endif VMS

#ifdef TRAVERSAL
	if((ofp = fopen(TRAVERSE_ERRORS,"a+")) == NULL) {
		perror("unable to open traversal errors output file");
		exit(1);
	}

	fprintf(ofp,"%s	%s 	in %s\n",links[cur].lname, links[cur].target,
		filename);
	fclose(ofp);
#endif TRAVERSAL

#endif MSDOS

	return;
}
