#include "defs.h"
 
/*
 * push the current filename, link and line number onto the history list
 */

PUBLIC void push ARGS8(char *,fname, int,cur, int,line, char *,hlight, 
			char *,gopher_info, char *,real_name, FILE **,fp, 
			HTAnchor *,www_destination)
{
    if( *fname == '\0')  /* dont push null file names */
	return;

    if( STREQ(history[nhist-1].hfname, fname) &&
        history[nhist-1].hlinkno == cur &&
        history[nhist-1].hpageno == line &&
        STREQ(history[nhist-1].hightext, hlight) ) 
        return;  /* file is identical to one before it don't push it */

    if( STREQ(history[nhist-2].hfname, fname) &&
        history[nhist-2].hlinkno == cur &&
        history[nhist-2].hpageno == line &&
        STREQ(history[nhist-2].hightext, hlight) ) { 
	  nhist--; /* pop one off the stack */
          return;  /* file is identical to one two before it don't push it */
    }

    if(lynx_mode == FORMS_LYNX_MODE && nlinks > 0) {
	save_form(line, fp, fname);
    }


    if (nhist<MAXHIST)  {
	strcpy(history[nhist].hfname, fname);
	history[nhist].hlinkno = cur;
	history[nhist].hpageno = line;
	history[nhist].www_destination = www_destination;
	strcpy(history[nhist].hightext, hlight);
	strcpy(history[nhist].gopher_info, gopher_info);
	strcpy(history[nhist].real_name, real_name);
	nhist++;
    }
}


/*
 * pop the previous filename, link and line number from the history list
 */
PUBLIC char *pop ARGS6(int *,cur, int *,line, char *,prev_link_name, 
		       char *,gopher_info, char *,real_name, 
		       HTAnchor **,www_destination)
{
 
    if (nhist>0) {
	nhist--;
	*cur = history[nhist].hlinkno;
	*line = history[nhist].hpageno;
	*www_destination = history[nhist].www_destination;
	strcpy(prev_link_name, history[nhist].hightext);
	strcpy(gopher_info, history[nhist].gopher_info);
	strcpy(real_name, history[nhist].real_name);
	return(history[nhist].hfname);
    } else {
	return(" ");
    }
}

/*
 * pop the specified hist entry, link and line number from the history list
 * but don't actually remove the entry, just return it.
 * this procedure is badly named :)
 */
PUBLIC char *pop_num ARGS7(int,number, int *,cur, int *,line, 
			   char *,prev_link_name, char *,gopher_info, 
			   char *,real_name, HTAnchor **,www_destination)
{
    if (nhist>= number) {
	*cur = history[number].hlinkno;
	*line = history[number].hpageno;
	*www_destination = history[number].www_destination;
	strcpy(prev_link_name, history[number].hightext);
	strcpy(gopher_info, history[number].gopher_info);
	strcpy(real_name, history[number].real_name);
	return(history[number].hfname);
    } else {
	return(" ");
    }
}
